Index: pom.xml
===================================================================
--- pom.xml	(revision 44197)
+++ pom.xml	(revision 44198)
@@ -349,16 +349,6 @@
                 <artifactId>commons-cli</artifactId>
                 <version>1.4</version>
             </dependency>
-<!--            <dependency>
-                <groupId>commons-io</groupId>
-                <artifactId>commons-io</artifactId>
-                <version>2.4</version>
-            </dependency>-->
-<!--            <dependency>
-                <groupId>org.apache.commons</groupId>
-                <artifactId>commons-lang3</artifactId>
-                <version>3.1</version>
-            </dependency>-->
             <dependency>
                 <groupId>commons-lang</groupId>
                 <artifactId>commons-lang</artifactId>
@@ -390,17 +380,17 @@
                 <artifactId>commons-pool</artifactId>
                 <version>1.6</version>
             </dependency>
-
             <dependency>
+                <groupId>org.apache.commons</groupId>
+                <artifactId>commons-text</artifactId>
+                <version>1.6</version>
+            </dependency>
+            
+            <dependency>
                 <groupId>org.dspace</groupId>
                 <artifactId>cql-java</artifactId>
                 <version>1.0</version>
             </dependency>
-<!--            <dependency>
-                <groupId>easymock</groupId>
-                <artifactId>easymock</artifactId>
-                <version>1.2_Java1.3</version>
-            </dependency>-->
             <dependency>
                 <groupId>easymock</groupId>
                 <artifactId>easymockclassextension</artifactId>
@@ -411,16 +401,6 @@
                 <artifactId>flanagan</artifactId>
                 <version>20090616</version>
             </dependency>
-<!--            <dependency>
-                <groupId>net.sf</groupId>
-                <artifactId>flib-jcalendar</artifactId>
-                <version>unknown</version>
-            </dependency>-->
-<!--            <dependency>
-                    <groupId>com.jeta</groupId>
-                    <artifactId>formsrt</artifactId>
-                    <version>2.1.0_M3-1</version>
-            </dependency>-->
             <dependency>
                 <groupId>org.opengis</groupId>
                 <artifactId>geoapi</artifactId>
@@ -638,11 +618,6 @@
                 <artifactId>jzkit2-origin</artifactId>
                 <version>2.0.0</version>
             </dependency>
-<!--            <dependency>
-                <groupId>net.sf.kxml</groupId>
-                <artifactId>kxml2</artifactId>
-                <version>2.2.2</version>
-            </dependency>-->
             <dependency>
                 <groupId>log4j</groupId>
                 <artifactId>log4j</artifactId>
@@ -653,22 +628,7 @@
                 <artifactId>log4jdbc</artifactId>
                 <version>1.2</version>
             </dependency>
-<!--            <dependency>
-                <groupId>com.jgoodies</groupId>
-                <artifactId>jgoodies-common</artifactId>
-                <version>1.4.0</version>
-            </dependency>
             <dependency>
-                <groupId>com.jgoodies</groupId>
-                <artifactId>jgoodies-forms</artifactId>
-                <version>1.6.0</version>
-            </dependency>
-            <dependency>
-                <groupId>com.jgoodies</groupId>
-                <artifactId>looks</artifactId>
-                <version>2.2.2</version>
-            </dependency>-->
-            <dependency>
                 <groupId>com.ostermiller</groupId>
                 <artifactId>ostermillerutils</artifactId>
                 <version>1.4.3</version>
@@ -738,17 +698,7 @@
                 <artifactId>sil</artifactId>
                 <version>0.43b-am1</version>
             </dependency>
-<!--            <dependency>
-                <groupId>org.slf4j</groupId>
-                <artifactId>slf4j-api</artifactId>
-                <version>1.5.5</version>
-            </dependency>
             <dependency>
-                <groupId>org.slf4j</groupId>
-                <artifactId>slf4j-log4j12</artifactId>
-                <version>1.5.5</version>
-            </dependency>-->
-            <dependency>
                 <groupId>net.sf.smc</groupId>
                 <artifactId>smc</artifactId>
                 <version>4.3</version>
@@ -863,53 +813,9 @@
             </dependency>
 <!--            <dependency>
                 <groupId>org.gvsig</groupId>
-                <artifactId>org.gvsig.tools.lib</artifactId>
-                <version>${gvsig.tools.version}</version>
-            </dependency>
-            <dependency>
-                <groupId>org.gvsig</groupId>
-                <artifactId>org.gvsig.tools.lib</artifactId>
-                <version>${gvsig.tools.version}</version>
-                <type>test-jar</type>
-                <scope>test</test>
-            </dependency>
-            <dependency>
-                <groupId>org.gvsig</groupId>
-                <artifactId>org.gvsig.tools.swing.api</artifactId>
-                <version>${gvsig.tools.version}</version>
-            </dependency>
-            <dependency>
-                <groupId>org.gvsig</groupId>
-                <artifactId>org.gvsig.tools.swing.impl</artifactId>
-                <version>${gvsig.tools.version}</version>
-            </dependency>-->
-<!--
-            <dependency>
-                <groupId>org.gvsig</groupId>
-                <artifactId>org.gvsig.tools.dynform.api</artifactId>
-                <version>${gvsig.tools.version}</version>
-            </dependency>
-            <dependency>
-                <groupId>org.gvsig</groupId>
-                <artifactId>org.gvsig.tools.dynform.spi</artifactId>
-                <version>${gvsig.tools.version}</version>
-            </dependency>
-            <dependency>
-                <groupId>org.gvsig</groupId>
-                <artifactId>org.gvsig.tools.dynform.services</artifactId>
-                <version>${gvsig.tools.version}</version>
-            </dependency>
-            <dependency>
-                <groupId>org.gvsig</groupId>
-                <artifactId>org.gvsig.tools.dynform.impl</artifactId>
-                <version>${gvsig.tools.version}</version>
-            </dependency>-->
-
-            <dependency>
-                <groupId>org.gvsig</groupId>
                 <artifactId>org.gvsig.catalog</artifactId>
                 <version>2.0</version>
-            </dependency>
+            </dependency>-->
             <dependency>
                 <groupId>org.gvsig.external</groupId>
                 <artifactId>org.gvsig.external.jump</artifactId>
@@ -1113,11 +1019,11 @@
                 <artifactId>org.gvsig.newlayer.lib.impl</artifactId>
                 <version>2.0.242-SNAPSHOT</version>
             </dependency>
-            <dependency>
+<!--            <dependency>
                 <groupId>org.gvsig</groupId>
                 <artifactId>org.gvsig.newlayer.prov.generic</artifactId>
                 <version>2.0.46-SNAPSHOT</version>
-            </dependency>
+            </dependency>-->
             <dependency>
                 <groupId>org.gvsig</groupId>
                 <artifactId>org.gvsig.newlayer.prov.file</artifactId>
@@ -1153,20 +1059,8 @@
                 <artifactId>org.gvsig.fmap.geometry.api</artifactId>
                 <version>2.0.242-SNAPSHOT</version>
             </dependency>
-            <!--
             <dependency>
                 <groupId>org.gvsig</groupId>
-                <artifactId>org.gvsig.fmap.geometry.generalpath</artifactId>
-                <version>2.0.103-SNAPSHOT</version>
-            </dependency>
-            <dependency>
-                <groupId>org.gvsig</groupId>
-                <artifactId>org.gvsig.fmap.geometry.operation</artifactId>
-                <version>2.0.103-SNAPSHOT</version>
-            </dependency>
-            -->
-            <dependency>
-                <groupId>org.gvsig</groupId>
                 <artifactId>org.gvsig.fmap.geometry.jts</artifactId>
                 <version>2.0.242-SNAPSHOT</version>
             </dependency>
@@ -1408,13 +1302,6 @@
                 <artifactId>org.gvsig.installer.app.mainplugin</artifactId>
                 <version>2.0.242-SNAPSHOT</version>
             </dependency>
-            <!--
-                      <dependency>
-                        <groupId>org.gvsig</groupId>
-                        <artifactId>org.gvsig.symbology.app.mainplugin</artifactId>
-                        <version>2.0.10-SNAPSHOT</version>
-                      </dependency>
-            -->
             <dependency>
                 <groupId>org.gvsig</groupId>
                 <artifactId>org.gvsig.i18n.app.mainplugin</artifactId>
@@ -1435,15 +1322,8 @@
                 <artifactId>org.gvsig.newlayer.app.mainplugin</artifactId>
                 <version>2.0.242-SNAPSHOT</version>
             </dependency>
-            <!--
             <dependency>
                 <groupId>org.gvsig</groupId>
-                <artifactId>org.gvsig.help.app.mainplugin</artifactId>
-                <version>2.0.24-SNAPSHOT</version>
-            </dependency>
-            -->
-            <dependency>
-                <groupId>org.gvsig</groupId>
                 <artifactId>org.gvsig.timesupport.lib.api</artifactId>
                 <version>2.0.242-SNAPSHOT</version>
             </dependency>
@@ -2657,7 +2537,7 @@
 
         <jython.artifactId>jython-standalone</jython.artifactId>
         <!-- External project versions -->
-        <gvsig.tools.version>3.0.182</gvsig.tools.version>
+        <gvsig.tools.version>3.0.184-SNAPSHOT</gvsig.tools.version>
         <gvsig.proj.version>1.0.4</gvsig.proj.version>
         <gvsig.projection.api.version>2.0.25</gvsig.projection.api.version>
 