Index: DefaultCodeBuilder.java
===================================================================
--- DefaultCodeBuilder.java	(revision 44206)
+++ DefaultCodeBuilder.java	(revision 44207)
@@ -19,32 +19,32 @@
 import org.gvsig.expressionevaluator.CodeBuilder;
 import org.gvsig.expressionevaluator.Codes;
 import org.gvsig.expressionevaluator.ExpressionBuilder;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_ADD;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_AND;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_CONCAT;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_DIV;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_EQ;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_GE;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_GT;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_ILIKE;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_IS;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_LE;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_LIKE;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_LT;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_MOD;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_MULT;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_NE;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_NEGATE;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_NOT;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_OR;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_REGEXP;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_SUBST;
 import org.gvsig.expressionevaluator.ExpressionBuilder.Value;
 import org.gvsig.expressionevaluator.ExpressionUtils;
 import org.gvsig.expressionevaluator.Formatter;
 import org.gvsig.expressionevaluator.Function;
 import org.gvsig.expressionevaluator.Interpreter;
 import org.gvsig.expressionevaluator.SymbolTable;
-import org.gvsig.expressionevaluator.impl.function.operator.AddOperator;
-import org.gvsig.expressionevaluator.impl.function.operator.AndOperator;
-import org.gvsig.expressionevaluator.impl.function.operator.ConcatOperator;
-import org.gvsig.expressionevaluator.impl.function.operator.DivOperator;
-import org.gvsig.expressionevaluator.impl.function.operator.EqOperator;
-import org.gvsig.expressionevaluator.impl.function.operator.GeOperator;
-import org.gvsig.expressionevaluator.impl.function.operator.GtOperator;
-import org.gvsig.expressionevaluator.impl.function.operator.IsOperator;
-import org.gvsig.expressionevaluator.impl.function.operator.LeOperator;
-import org.gvsig.expressionevaluator.impl.function.operator.LtOperator;
-import org.gvsig.expressionevaluator.impl.function.operator.ModOperator;
-import org.gvsig.expressionevaluator.impl.function.operator.MulOperator;
-import org.gvsig.expressionevaluator.impl.function.operator.NeOperator;
-import org.gvsig.expressionevaluator.impl.function.operator.NegOperator;
-import org.gvsig.expressionevaluator.impl.function.operator.NotOperator;
-import org.gvsig.expressionevaluator.impl.function.operator.OrOperator;
-import org.gvsig.expressionevaluator.impl.function.operator.RegExpOperator;
-import org.gvsig.expressionevaluator.impl.function.operator.SubstOperator;
-import org.gvsig.expressionevaluator.impl.function.predicate.IlikeOperator;
-import org.gvsig.expressionevaluator.impl.function.predicate.LikeOperator;
 import org.gvsig.expressionevaluator.impl.function.programming.GetattrFunction;
 import org.gvsig.expressionevaluator.impl.function.programming.GetitemFunction;
 import org.gvsig.fmap.geom.Geometry;
@@ -417,7 +417,7 @@
             switch(this.type) {
                 case UNARY_OPERATOR:
                     return builder.function(
-                            NegOperator.NAME.equalsIgnoreCase(this.name())?
+                            OPERATOR_NEGATE.equalsIgnoreCase(this.name())?
                                 "-" :
                                 this.name(),
                             this.parameters().get(0).toValue(builder)
@@ -455,7 +455,7 @@
             StringBuilder builder = new StringBuilder();
             switch(this.type) {
                 case UNARY_OPERATOR:
-                    if( NegOperator.NAME.equalsIgnoreCase(this.name()) ) {
+                    if( OPERATOR_NEGATE.equalsIgnoreCase(this.name()) ) {
                         builder.append("-");
                     } else {
                         builder.append(this.name());
@@ -617,102 +617,102 @@
     
     @Override
     public Code not(Code op1) {
-        return operator(NotOperator.NAME, op1);
+        return operator(OPERATOR_NOT, op1);
     }
 
     @Override
     public Code negate(Code op1) {
-        return operator(NegOperator.NAME, op1);
+        return operator(OPERATOR_NEGATE, op1);
     }
 
     @Override
     public Code concat(Code op1, Code op2) {
-        return operator(ConcatOperator.NAME, op1, op2);
+        return operator(OPERATOR_CONCAT, op1, op2);
     }
 
     @Override
     public Code add(Code op1, Code op2) {
-        return operator(AddOperator.NAME, op1, op2);
+        return operator(OPERATOR_ADD, op1, op2);
     }
 
     @Override
     public Code subst(Code op1, Code op2) {
-        return operator(SubstOperator.NAME, op1, op2);
+        return operator(OPERATOR_SUBST, op1, op2);
     }
 
     @Override
     public Code mult(Code op1, Code op2) {
-        return operator(MulOperator.NAME, op1, op2);
+        return operator(OPERATOR_MULT, op1, op2);
     }
 
     @Override
     public Code div(Code op1, Code op2) {
-        return operator(DivOperator.NAME, op1, op2);
+        return operator(OPERATOR_DIV, op1, op2);
     }
 
     @Override
     public Code mod(Code op1, Code op2) {
-        return operator(ModOperator.NAME, op1, op2);
+        return operator(OPERATOR_MOD, op1, op2);
     }
 
     @Override
     public Code or(Code op1, Code op2) {
-        return operator(OrOperator.NAME, op1, op2);
+        return operator(OPERATOR_OR, op1, op2);
     }
 
     @Override
     public Code and(Code op1, Code op2) {
-        return operator(AndOperator.NAME, op1, op2);
+        return operator(OPERATOR_AND, op1, op2);
     }
 
     @Override
     public Code like(Code op1, Code op2) {
-        return operator(LikeOperator.NAME, op1, op2);
+        return operator(OPERATOR_LIKE, op1, op2);
     }
 
     @Override
     public Code ilike(Code op1, Code op2) {
-        return operator(IlikeOperator.NAME, op1, op2);
+        return operator(OPERATOR_ILIKE, op1, op2);
     }
 
     @Override
     public Code regexp(Code op1, Code op2) {
-        return operator(RegExpOperator.NAME, op1, op2);
+        return operator(OPERATOR_REGEXP, op1, op2);
     }
 
     @Override
     public Code lt(Code op1, Code op2) {
-        return operator(LtOperator.NAME, op1, op2);
+        return operator(OPERATOR_LT, op1, op2);
     }
 
     @Override
     public Code gt(Code op1, Code op2) {
-        return operator(GtOperator.NAME, op1, op2);
+        return operator(OPERATOR_GT, op1, op2);
     }
 
     @Override
     public Code le(Code op1, Code op2) {
-        return operator(LeOperator.NAME, op1, op2);
+        return operator(OPERATOR_LE, op1, op2);
     }
 
     @Override
     public Code ge(Code op1, Code op2) {
-        return operator(GeOperator.NAME, op1, op2);
+        return operator(OPERATOR_GE, op1, op2);
     }
 
     @Override
     public Code eq(Code op1, Code op2) {
-        return operator(EqOperator.NAME, op1, op2);
+        return operator(OPERATOR_EQ, op1, op2);
     }
 
     @Override
     public Code ne(Code op1, Code op2) {
-        return operator(NeOperator.NAME, op1, op2);
+        return operator(OPERATOR_NE, op1, op2);
     }
 
     @Override
     public Code is(Code op1, Code op2) {
-        return operator(IsOperator.NAME, op1, op2);
+        return operator(OPERATOR_IS, op1, op2);
     }
 
     @Override