Index: trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/java/org/gvsig/app/extension/ProjectExtension.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/java/org/gvsig/app/extension/ProjectExtension.java	(revision 44236)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/java/org/gvsig/app/extension/ProjectExtension.java	(revision 44237)
@@ -72,6 +72,9 @@
 import org.gvsig.app.project.documents.gui.ProjectWindow;
 import org.gvsig.app.project.documents.gui.projectpanel.ProjectDocumentsPanelPageFactory;
 import org.gvsig.app.project.documents.view.ViewManager;
+import org.gvsig.filedialogchooser.FileDialogChooser;
+import org.gvsig.filedialogchooser.FileDialogChooserManager;
+import static org.gvsig.fmap.dal.serverexplorer.filesystem.swing.FilesystemExplorerWizardPanelController.OPEN_LAYER_FILE_CHOOSER_ID;
 import org.gvsig.gui.beans.swing.JFileChooser;
 import org.gvsig.propertypage.PropertiesPageManager;
 import org.gvsig.tools.ToolsLocator;
@@ -265,10 +268,8 @@
         }
 
         if (file == null) {
-            Preferences prefs = Preferences.userRoot().node("gvsig.foldering");
-            JFileChooser jfc = new JFileChooser(PROJECT_FILE_CHOOSER_ID,
-                    prefs.get("ProjectsFolder", null));
-
+            FileDialogChooserManager fileDialogChooserManager = ToolsUtilLocator.getFileDialogChooserManager();
+            FileDialogChooser jfc = fileDialogChooserManager.create(PROJECT_FILE_CHOOSER_ID);
             jfc.setDialogTitle(PluginServices.getText(this, "guardar_proyecto"));
 
             GenericFileFilter projExtensionFilter = new GenericFileFilter(
@@ -363,8 +364,8 @@
             }
 
             if (projectFile == null) {
-                Preferences prefs = Preferences.userRoot().node("gvsig.foldering");
-                JFileChooser jfc = new JFileChooser(PROJECT_FILE_CHOOSER_ID, prefs.get("ProjectsFolder", null));
+                FileDialogChooserManager fileDialogChooserManager = ToolsUtilLocator.getFileDialogChooserManager();
+                FileDialogChooser jfc = fileDialogChooserManager.create(PROJECT_FILE_CHOOSER_ID);
                 ProjectPreviewPanel preview = new ProjectPreviewPanel();
                 jfc.setAccessory(preview);
                 jfc.addPropertyChangeListener(preview);
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/java/org/gvsig/app/project/documents/view/legend/gui/LegendManager.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/java/org/gvsig/app/project/documents/view/legend/gui/LegendManager.java	(revision 44236)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/java/org/gvsig/app/project/documents/view/legend/gui/LegendManager.java	(revision 44237)
@@ -63,6 +63,9 @@
 
 import org.gvsig.andami.PluginServices;
 import org.gvsig.andami.messages.NotificationManager;
+import org.gvsig.fmap.dal.serverexplorer.filesystem.FilesystemServerExplorer;
+import org.gvsig.fmap.dal.serverexplorer.filesystem.FilesystemServerExplorerParameters;
+import static org.gvsig.fmap.dal.serverexplorer.filesystem.swing.FilesystemExplorerWizardPanel.OPEN_LAYER_FILE_CHOOSER_ID;
 import org.gvsig.fmap.mapcontext.exceptions.LegendLayerException;
 import org.gvsig.fmap.mapcontext.layers.FLayer;
 import org.gvsig.fmap.mapcontext.layers.FLayers;
@@ -75,6 +78,8 @@
 import org.gvsig.symbology.SymbologyLocator;
 import org.gvsig.symbology.swing.SymbologySwingLocator;
 import org.gvsig.symbology.swing.SymbologySwingManager;
+import org.gvsig.tools.ToolsLocator;
+import org.gvsig.tools.folders.FoldersManager;
 
 /**
  * Implements the panel which allows the user to control all the information
@@ -147,8 +152,11 @@
 
     public static String defaultLegendFolderPath;
     {
-        Preferences prefs = Preferences.userRoot().node("gvsig.foldering");
-        defaultLegendFolderPath = prefs.get("LegendsFolder", "");
+        FoldersManager folderManager = ToolsLocator.getFoldersManager();
+        defaultLegendFolderPath = folderManager.getLastPath(
+                "LegendsFolder", 
+                folderManager.getHome()
+        ).getAbsolutePath();
     }
 
 
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/java/org/gvsig/fmap/dal/serverexplorer/filesystem/swing/FilesystemExplorerWizardPanel.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/java/org/gvsig/fmap/dal/serverexplorer/filesystem/swing/FilesystemExplorerWizardPanel.java	(revision 44236)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/java/org/gvsig/fmap/dal/serverexplorer/filesystem/swing/FilesystemExplorerWizardPanel.java	(revision 44237)
@@ -47,6 +47,7 @@
 import org.gvsig.tools.dispose.DisposeUtils;
 import org.gvsig.tools.dynobject.DynField;
 import org.gvsig.tools.dynobject.DynObject;
+import org.gvsig.tools.folders.FoldersManager;
 import org.gvsig.tools.i18n.I18nManager;
 import org.gvsig.tools.identitymanagement.UnauthorizedException;
 import org.gvsig.tools.swing.api.ToolsSwingLocator;
@@ -74,7 +75,7 @@
     protected FilesystemServerExplorer explorer;
     private ArrayList<MyFileFilter> filters;
 
-    private static String lastPath = null;
+//    private static String lastPath = null;
     private FilesystemExplorerWizardPanelController panel = null;
     private boolean tabularOnly;
     /**
@@ -110,10 +111,6 @@
     public void initWizard() {
         I18nManager i18nManager = ToolsLocator.getI18nManager();
         setTabName(i18nManager.getTranslation("Fichero"));
-        if (lastPath == null) {
-            Preferences prefs = Preferences.userRoot().node("gvsig.foldering");
-            lastPath = prefs.get("DataFolder", System.getProperty("user.home"));
-        }
         initExplorer();
         initFilters();
         initUI();
@@ -212,9 +209,15 @@
             DataManager dm = DALLocator.getDataManager();
             FilesystemServerExplorerParameters param;
             try {
+                FoldersManager folderManager = ToolsLocator.getFoldersManager();
                 param = (FilesystemServerExplorerParameters) dm
                         .createServerExplorerParameters(FilesystemServerExplorer.NAME);
-                param.setInitialpath(lastPath);
+                param.setInitialpath(
+                        folderManager.getLastPath(
+                                OPEN_LAYER_FILE_CHOOSER_ID, 
+                                folderManager.getHome()
+                        ).getAbsolutePath()
+                );
                 explorer = (FilesystemServerExplorer) dm.openServerExplorer(
                                 FilesystemServerExplorer.NAME, param);
             } catch (Exception e) {
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/java/org/gvsig/fmap/dal/serverexplorer/filesystem/swing/FilesystemExplorerWizardPanelController.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/java/org/gvsig/fmap/dal/serverexplorer/filesystem/swing/FilesystemExplorerWizardPanelController.java	(revision 44236)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/java/org/gvsig/fmap/dal/serverexplorer/filesystem/swing/FilesystemExplorerWizardPanelController.java	(revision 44237)
@@ -29,6 +29,7 @@
 import org.gvsig.app.ApplicationManager;
 import org.gvsig.app.prepareAction.PrepareContext;
 import org.gvsig.filedialogchooser.FileDialogChooser;
+import org.gvsig.filedialogchooser.FileDialogChooserManager;
 import org.gvsig.fmap.dal.DataStore;
 import org.gvsig.fmap.dal.DataStoreParameters;
 import org.gvsig.fmap.dal.exception.DataException;
@@ -299,8 +300,9 @@
 
      private List<FilesystemStoreParameters> chooseFilesParameters() {
 
-        FileDialogChooser fileChooser = ToolsUtilLocator.getFileDialogChooserManager().create(OPEN_LAYER_FILE_CHOOSER_ID);
-        fileChooser.setCurrentDirectory(explorer.getCurrentPath());
+        FileDialogChooserManager fileDialogChooserManager = ToolsUtilLocator.getFileDialogChooserManager();
+        FileDialogChooser fileChooser = fileDialogChooserManager.create(OPEN_LAYER_FILE_CHOOSER_ID);
+        fileChooser.setCurrentDirectory(fileDialogChooserManager.getLastPath(OPEN_LAYER_FILE_CHOOSER_ID, explorer.getCurrentPath()));
         fileChooser.setMultiSelectionEnabled(true);
         fileChooser.setAcceptAllFileFilterUsed(false);
 
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.ui/src/main/java/org/gvsig/gui/beans/swing/JFileChooser.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.ui/src/main/java/org/gvsig/gui/beans/swing/JFileChooser.java	(revision 44236)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.ui/src/main/java/org/gvsig/gui/beans/swing/JFileChooser.java	(revision 44237)
@@ -47,7 +47,7 @@
  * 
  * 
  * @author jaume dominguez faus - jaume.dominguez@iver.es Dec 5, 2007
- *
+ * @deprecated use FolderManager or FileDialogChosserManager
  */
 public class JFileChooser extends javax.swing.JFileChooser {
 	private static final long serialVersionUID = -2419775752576400974L;