Index: SelectFormatPanelView.java
===================================================================
--- SelectFormatPanelView.java	(revision 44385)
+++ SelectFormatPanelView.java	(revision 44386)
@@ -1,14 +1,16 @@
 package org.gvsig.export.swing.impl.panels;
 
-import com.jeta.open.i18n.I18NUtils;
 import com.jgoodies.forms.layout.CellConstraints;
 import com.jgoodies.forms.layout.FormLayout;
 import java.awt.BorderLayout;
 import java.awt.ComponentOrientation;
 import java.awt.Container;
 import java.awt.Dimension;
+import java.awt.event.WindowAdapter;
+import java.awt.event.WindowEvent;
 import javax.swing.Box;
 import javax.swing.ImageIcon;
+import javax.swing.JButton;
 import javax.swing.JFrame;
 import javax.swing.JLabel;
 import javax.swing.JList;
@@ -23,6 +25,8 @@
    JList lstServices = new JList();
    JTextArea txtDescription = new JTextArea();
    JLabel lblEmpty = new JLabel();
+   JButton btnBookmark = new JButton();
+   JButton btnHistory = new JButton();
 
    /**
     * Default constructor
@@ -33,6 +37,26 @@
    }
 
    /**
+    * Main method for panel
+    */
+   public static void main(String[] args)
+   {
+      JFrame frame = new JFrame();
+      frame.setSize(600, 400);
+      frame.setLocation(100, 100);
+      frame.getContentPane().add(new SelectFormatPanelView());
+      frame.setVisible(true);
+
+      frame.addWindowListener( new WindowAdapter()
+      {
+         public void windowClosing( WindowEvent evt )
+         {
+            System.exit(0);
+         }
+      });
+   }
+
+   /**
     * Adds fill components to empty cells in the first row and first column of the grid.
     * This ensures that the grid spacing will be the same as shown in the designer.
     * @param cols an array of column indices in the first row where fill components should be added.
@@ -114,7 +138,7 @@
    public JPanel createPanel()
    {
       JPanel jpanel1 = new JPanel();
-      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:NONE,FILL:DEFAULT:GROW(1.0),FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE,FILL:DEFAULT:GROW(0.8),CENTER:DEFAULT:NONE,FILL:DEFAULT:GROW(0.2),CENTER:DEFAULT:NONE");
+      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:NONE,FILL:DEFAULT:GROW(1.0),FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE,CENTER:7PX:NONE,FILL:DEFAULT:GROW(0.5),CENTER:DEFAULT:NONE,FILL:DEFAULT:GROW(0.1),CENTER:DEFAULT:NONE");
       CellConstraints cc = new CellConstraints();
       jpanel1.setLayout(formlayout1);
 
@@ -123,7 +147,7 @@
       jscrollpane1.setViewportView(lstServices);
       jscrollpane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
       jscrollpane1.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
-      jpanel1.add(jscrollpane1,cc.xy(2,2));
+      jpanel1.add(jscrollpane1,cc.xy(2,3));
 
       txtDescription.setEditable(false);
       txtDescription.setName("txtDescription");
@@ -133,15 +157,37 @@
       jscrollpane2.setViewportView(txtDescription);
       jscrollpane2.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
       jscrollpane2.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
-      jpanel1.add(jscrollpane2,cc.xy(2,4));
+      jpanel1.add(jscrollpane2,cc.xy(2,5));
 
       lblEmpty.setName("lblEmpty");
-      jpanel1.add(lblEmpty,cc.xy(2,5));
+      jpanel1.add(lblEmpty,cc.xy(2,6));
 
-      addFillComponents(jpanel1,new int[]{ 1,2,3 },new int[]{ 1,2,3,4,5 });
+      jpanel1.add(createPanel1(),new CellConstraints(2,1,1,1,CellConstraints.RIGHT,CellConstraints.DEFAULT));
+      addFillComponents(jpanel1,new int[]{ 1,2,3 },new int[]{ 1,2,3,4,5,6 });
       return jpanel1;
    }
 
+   public JPanel createPanel1()
+   {
+      JPanel jpanel1 = new JPanel();
+      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:NONE,FILL:7PX:NONE,FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE");
+      CellConstraints cc = new CellConstraints();
+      jpanel1.setLayout(formlayout1);
+
+      btnBookmark.setName("btnBookmark");
+      EmptyBorder emptyborder1 = new EmptyBorder(0,0,0,0);
+      btnBookmark.setBorder(emptyborder1);
+      jpanel1.add(btnBookmark,cc.xy(3,1));
+
+      btnHistory.setName("btnHistory");
+      EmptyBorder emptyborder2 = new EmptyBorder(0,0,0,0);
+      btnHistory.setBorder(emptyborder2);
+      jpanel1.add(btnHistory,cc.xy(1,1));
+
+      addFillComponents(jpanel1,new int[]{ 2 },new int[0]);
+      return jpanel1;
+   }
+
    /**
     * Initializer
     */