Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/DefaultDataSwingManager.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/DefaultDataSwingManager.java	(revision 44409)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/DefaultDataSwingManager.java	(revision 44410)
@@ -22,12 +22,15 @@
  */
 package org.gvsig.fmap.dal.swing.impl;
 
+import java.awt.Component;
 import java.util.Collection;
 import java.util.Collections;
 import java.util.LinkedHashMap;
 import java.util.List;
 import java.util.Map;
 import java.util.function.Predicate;
+import javax.swing.AbstractButton;
+import javax.swing.Action;
 import javax.swing.JButton;
 import javax.swing.JComboBox;
 import javax.swing.JList;
@@ -82,6 +85,7 @@
 import org.gvsig.tools.dynobject.DynStruct;
 import org.gvsig.tools.exception.BaseException;
 import org.gvsig.fmap.dal.swing.DALActionFactory;
+import org.gvsig.fmap.dal.swing.DALActionFactory.DALActionContext;
 import org.gvsig.fmap.dal.swing.impl.featuretable.SimpleFeaturesTableModel;
 import org.gvsig.fmap.dal.swing.impl.jdbc.DefaultJDBCConnectionDialog;
 import org.gvsig.fmap.dal.swing.impl.jdbc.JDBCConnectionPickerController;
@@ -299,7 +303,21 @@
         DALActionFactory action = this.featureStoreSearchActions.get(name.toLowerCase());
         return action;
     }
+    
+    @Override
+    public void setStoreAction(AbstractButton component, String name, boolean preserveLabel, DALActionContext context) {
+        DALActionFactory factory = this.getStoreAction(name);
+        Action action = factory.createAction(context);
+        if( preserveLabel ) {
+            String s = component.getText();
+            component.setAction(action);
+            component.setText(s);
+        } else {
+            component.setAction(action);
+        }
+    }
 
+
     @Override
     public PickerController<JDBCServerExplorerParameters> createJDBCConnectionPickerController(
             JComboBox cboConnection, JButton btnConnection
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.api/src/main/java/org/gvsig/fmap/dal/swing/DataSwingManager.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.api/src/main/java/org/gvsig/fmap/dal/swing/DataSwingManager.java	(revision 44409)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.api/src/main/java/org/gvsig/fmap/dal/swing/DataSwingManager.java	(revision 44410)
@@ -22,9 +22,11 @@
  */
 package org.gvsig.fmap.dal.swing;
 
+import java.awt.Component;
 import java.util.Collection;
 import java.util.List;
 import java.util.function.Predicate;
+import javax.swing.AbstractButton;
 import javax.swing.JButton;
 import javax.swing.JComboBox;
 import javax.swing.JList;
@@ -44,6 +46,7 @@
 import org.gvsig.fmap.dal.feature.FeatureType;
 import org.gvsig.fmap.dal.feature.paging.FeaturePagingHelper;
 import org.gvsig.fmap.dal.store.jdbc.JDBCServerExplorerParameters;
+import org.gvsig.fmap.dal.swing.DALActionFactory.DALActionContext;
 import org.gvsig.fmap.dal.swing.expressionevaluator.FeatureStoreElement;
 import org.gvsig.fmap.dal.swing.featuretype.AttributeDescriptorPickerController;
 import org.gvsig.fmap.dal.swing.featuretype.FeatureTypeAttributePanel;
@@ -111,6 +114,8 @@
     public  Collection<DALActionFactory> getStoreActions();
 
     public  DALActionFactory getStoreAction(String name);
+    
+    public void setStoreAction(AbstractButton component, String name, boolean preserveLabel, DALActionContext context);
 
     public PickerController<JDBCServerExplorerParameters> createJDBCConnectionPickerController(
             JComboBox cboConnection, JButton btnConnection